<template>
  <Dialog v-model="dialogVisible" title="选择物料" style="width: 1100px; max-height: 800px">
    <ContentWrap>
      <el-form
        class="-mb-15px"
        :model="queryParams"
        ref="queryFormRef"
        :inline="true"
        label-width="68px"
      >
        <el-form-item label="物料名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入物料名称"
            clearable
            @keyup.enter="handleQuery"
            class="!w-240px"
          />
        </el-form-item>
        <el-form-item label="物料编码" prop="code">
          <el-input
            v-model="queryParams.code"
            placeholder="请输入物料编码"
            clearable
            @keyup.enter="handleQuery"
            class="!w-240px"
          />
        </el-form-item>
        <el-form-item>
          <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
          <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        </el-form-item>
      </el-form>
    </ContentWrap>
    <ContentWrap>
      <el-table
        v-loading="loading"
        :data="list"
        :stripe="true"
        :show-overflow-tooltip="true"
        @row-click="handleRowClick"
      >
        <el-table-column width="60" label="选择">
          <template #default="{ row }">
            <el-radio
              :model-value="selectedRow?.id"
              :label="row.id"
              @click.stop="selectRow(row)"
              class="no-label-radio"
            />
          </template>
        </el-table-column>
        <el-table-column
          label="物料编码"
          align="center"
          prop="code"
          :show-overflow-tooltip="true"
        />
        <el-table-column
          label="物料名称"
          align="center"
          prop="name"
          :show-overflow-tooltip="true"
        />
        <el-table-column label="规格型号" align="center" prop="model" width="120" />
        <el-table-column label="单位" align="center" prop="unit" width="120" />
        <el-table-column label="状态" key="status">
          <template #default="scope">
            <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status" />
          </template>
        </el-table-column>
        <el-table-column
          label="创建时间"
          align="center"
          prop="createTime"
          :formatter="dateFormatter"
          width="180"
        />
      </el-table>
      <!-- 分页 -->
      <Pagination
        :total="total"
        v-model:page="queryParams.pageNo"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
      />
    </ContentWrap>
  </Dialog>
</template>

<script setup lang="ts">
import { DictDataVO } from '@/api/system/dict/dict.data'
import { dateFormatter } from '@/utils/formatTime'
import * as DictTypeApi from '@/api/system/dict/dict.type'
import * as MaterialApi from '@/api/pms/material'
import {DICT_TYPE} from "@/utils/dict";

const emit = defineEmits(['choose']) // 定义 success 事件，用于操作成功后的回调
const dialogVisible = ref(false) // 弹窗的是否展示
const loading = ref(true) // 列表的加载中
const queryFormRef = ref() // 搜索的表单
const list = ref<DictDataVO[]>([]) // 列表的数据
const dictTypeList = ref<DictTypeApi.DictTypeVO[]>() // 字典类型的列表
const total = ref(0) // 列表的总页数

// 默认查询参数
const defaultQueryParams = {
  pageNo: 1,
  pageSize: 10,
  name: '',
  code: '',
  status: undefined,
}

const queryParams = reactive({
  ...defaultQueryParams
})

const selectedRow = ref(null)

// 处理单选逻辑
const selectRow = (row) => {
  selectedRow.value = selectedRow.value?.id === row.id ? null : row
  emit('choose', row)
  dialogVisible.value = false
}

// 点击整行选中
const handleRowClick = (row) => {
  selectRow(row)
}
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  selectedRow.value = null

  // 重置查询条件
  Object.assign(queryParams, defaultQueryParams)

  // 如果有表单引用，重置表单
  if (queryFormRef.value) {
    queryFormRef.value.resetFields()
  }

  await getList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗
const getList = async () => {
  loading.value = true
  try {
    const data = await MaterialApi.getMaterialPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}
const choose = (row: DictDataVO) => {
  emit('choose', row)
  dialogVisible.value = false
}
/** 重置按钮操作 */
const resetQuery = () => {
  // 使用默认参数重置查询条件
  Object.assign(queryParams, defaultQueryParams)

  // 如果有表单引用，重置表单
  if (queryFormRef.value) {
    queryFormRef.value.resetFields()
  }

  handleQuery()
}

</script>
<style lang="scss">
.no-label-radio .el-radio__label {
  display: none;
}
.no-label-radio .el-radio__inner {
  margin-right: 0;
}
</style>
